'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PersonType = exports.StaRHType = exports.StaRH = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _tcomb = require('tcomb');

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _model = require('./model');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var $context = new _uri2.default('https://github.com/ResourcefulHumans/staRHs-models#StaRH');
var PositiveIntegerType = (0, _tcomb.refinement)(_tcomb.Number, function (n) {
  return n > 0 && n % 1 === 0;
}, 'PositiveIntegerType');

var StaRH = exports.StaRH = function (_Model) {
  _inherits(StaRH, _Model);

  /**
   * @param {{from: PersonType, to: PersonType, amount: number, message: string}} fields
   */
  function StaRH(fields) {
    _classCallCheck(this, StaRH);

    var _this = _possibleConstructorReturn(this, (StaRH.__proto__ || Object.getPrototypeOf(StaRH)).call(this, $context));

    var from = fields.from,
        to = fields.to,
        amount = fields.amount,
        message = fields.message;

    PersonType(from);
    PersonType(to);
    PositiveIntegerType(amount);
    (0, _tcomb.String)(message);
    _this.from = from;
    _this.to = to;
    _this.amount = amount;
    _this.message = message;
    return _this;
  }

  /**
   * @returns {{from: string, to: string, amount: number, message: string, $context: string, $links: Array<{href: string, $context: string}>}}
   */


  _createClass(StaRH, [{
    key: 'toJSON',
    value: function toJSON() {
      return (0, _lodash.merge)(_get(StaRH.prototype.__proto__ || Object.getPrototypeOf(StaRH.prototype), 'toJSON', this).call(this), {
        from: {
          name: this.from.name,
          avatar: this.from.avatar.toString()
        },
        to: {
          name: this.to.name,
          avatar: this.to.avatar.toString()
        },
        amount: this.amount,
        message: this.message
      });
    }

    /**
     * @param {{from: {name: string, avatar: string}, to: {name: string, avatar: string}, amount: number, message: string}} data
     * @returns {StaRH}
     */

  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      return new StaRH({
        from: {
          name: data.from.name,
          avatar: new _uri2.default(data.from.avatar)
        },
        to: {
          name: data.to.name,
          avatar: new _uri2.default(data.to.avatar)
        },
        amount: data.amount,
        message: data.message
      });
    }

    /**
     * @returns {URIValue}
     */

  }, {
    key: '$context',
    get: function get() {
      return $context;
    }
  }]);

  return StaRH;
}(_model.Model);

var StaRHType = exports.StaRHType = (0, _tcomb.irreducible)('StaRHType', function (x) {
  return x instanceof StaRH;
});
var PersonType = exports.PersonType = (0, _tcomb.struct)({ name: _tcomb.String, avatar: _uri2.default.Type }, 'PersonType');